﻿@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Portal.Models.FluctuationMonitoring;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@Html.Common().DevExpress().GridView(
setting =>
{

    setting.Name = "FMGrid";
    setting.Width = Unit.Percentage(100);
    setting.Settings.ShowFilterRow = true;
    setting.Settings.ShowFilterRowMenu = true;
    setting.Settings.ShowColumnHeaders = true;
    setting.KeyFieldName = "PRODUCTION_MONTH;FORECAST_TYPE;SUPPLIER_CD;SUPPLIER_PLANT;PART_NO";

    setting.CallbackRouteValues = new { Controller = "FluctuationMonitoring", Action = "FluctuationGrid" };
    setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
    setting.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
    setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
    setting.SettingsBehavior.AllowSelectByRowClick = true;
    setting.SettingsLoadingPanel.Mode = GridViewLoadingPanelMode.Disabled;

    setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
    setting.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
    setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    setting.Styles.Header.VerticalAlign = VerticalAlign.Middle;

    setting.SettingsPager.FirstPageButton.Visible = true;
    setting.SettingsPager.LastPageButton.Visible = true;
    setting.SettingsPager.ShowNumericButtons = true;
    setting.SettingsPager.Position = PagerPosition.Bottom;
    setting.SettingsPager.PageSizeItemSettings.Visible = true;
    setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";

    setting.Columns.Add(col =>
    {
        col.FieldName = "SUPPLIER_CD";
        col.Caption = "Supplier CD.";
        col.Width = Unit.Pixel(80);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "SUPPLIER_NAME";
        col.Caption = "Supplier Name";
        col.Width = Unit.Pixel(250);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "PART_NO";
        col.Caption = "Part No.";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "PART_NAME";
        col.Caption = "Part Name";
        col.Width = Unit.Pixel(250);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOCK_CD";
        col.Caption = "Dock";
        col.Width = Unit.Pixel(60);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.AddBand(
    columnBand =>
    {
        columnBand.SetHeaderTemplateContent(
        content =>
        {
            Html.DevExpress().Label(label =>
            {
                label.Name = "NMonth" + columnBand.VisibleIndex;
                label.Text = "(N)";

                if (Model.GetModel<FluctuationMonitoringData>().FMGridData != null)
                {
                    if (Model.GetModel<FluctuationMonitoringData>().FMGridData.Count > 0)
                    {
                        var visibleIndex = columnBand.VisibleIndex >= 0 ? columnBand.VisibleIndex : 0;

                        String packMonth = Convert.ToString(DataBinder.Eval(Model.GetModel<FluctuationMonitoringData>().FMGridData[visibleIndex], "PRODUCTION_MONTH"));
                        DateTime parseMonth = DateTime.ParseExact(packMonth, "yyyyMM", System.Globalization.CultureInfo.InvariantCulture);
                        String monthName = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(parseMonth.Month);

                        label.Text = monthName.Substring(0, 3) + " '" + parseMonth.Year.ToString().Substring(2, 2) + " (N)";
                    }
                }
            }).Render();
        });

        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_VOLUME";
            column.Caption = "Qty";
            column.Width = Unit.Pixel(60);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });

        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_FA";
            column.Caption = "F/A Firm";
            column.Width = Unit.Pixel(80);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_FLUCTUATION";
            column.Caption = "Fluct. Category";
            //column.Width = Unit.Pixel(50);
            column.Settings.FilterMode = ColumnFilterMode.Value;
            column.ColumnType = MVCxGridViewColumnType.ComboBox;
            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
            comboSetting.Items.Add("", "");
            comboSetting.Items.Add("HIGH", "HIGH");
            comboSetting.Items.Add("MEDIUM", "MEDIUM");
            comboSetting.Items.Add("NORMAL", "NORMAL");
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "T_N_FA";
            column.Caption = "F/A Tentative";
            column.Width = Unit.Pixel(90);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "T_N_FLUCTUATION";
            column.Caption = "Fluct. Category";
            //column.Width = Unit.Pixel(50);
            column.Settings.FilterMode = ColumnFilterMode.Value;
            column.ColumnType = MVCxGridViewColumnType.ComboBox;
            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
            comboSetting.Items.Add("", "");
            comboSetting.Items.Add("HIGH", "HIGH");
            comboSetting.Items.Add("MEDIUM", "MEDIUM");
            comboSetting.Items.Add("NORMAL", "NORMAL");
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
    });

    setting.Columns.AddBand(
    columnBand =>
    {
        columnBand.SetHeaderTemplateContent(
        content =>
        {
            Html.DevExpress().Label(label =>
            {
                label.Name = "N1Month" + columnBand.VisibleIndex;
                label.Text = "(N + 1)";

                if (Model.GetModel<FluctuationMonitoringData>().FMGridData != null)
                {
                    if (Model.GetModel<FluctuationMonitoringData>().FMGridData.Count > 0)
                    {
                        var visibleIndex = columnBand.VisibleIndex >= 0 ? columnBand.VisibleIndex : 0;

                        String packMonth = Convert.ToString(DataBinder.Eval(Model.GetModel<FluctuationMonitoringData>().FMGridData[visibleIndex], "PRODUCTION_MONTH"));
                        DateTime parseMonth = DateTime.ParseExact(packMonth, "yyyyMM", System.Globalization.CultureInfo.InvariantCulture).AddMonths(1);
                        String monthName = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(parseMonth.Month);

                        label.Text = monthName.Substring(0, 3) + " '" + parseMonth.Year.ToString().Substring(2, 2) + " (N + 1)";
                    }
                }
            }).Render();
        });

        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_1_VOLUME";
            column.Caption = "Qty";
            column.Width = Unit.Pixel(60);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });

        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_1_FA";
            column.Caption = "F/A Firm";
            column.Width = Unit.Pixel(80);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_1_FLUCTUATION";
            column.Caption = "Fluct. Category";
            //column.Width = Unit.Pixel(50);
            column.Settings.FilterMode = ColumnFilterMode.Value;
            column.ColumnType = MVCxGridViewColumnType.ComboBox;
            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
            comboSetting.Items.Add("", "");
            comboSetting.Items.Add("HIGH", "HIGH");
            comboSetting.Items.Add("MEDIUM", "MEDIUM");
            comboSetting.Items.Add("NORMAL", "NORMAL");
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "T_N_1_FA";
            column.Caption = "F/A Tentative";
            column.Width = Unit.Pixel(90);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "T_N_1_FLUCTUATION";
            column.Caption = "Fluct. Category";
            //column.Width = Unit.Pixel(50);
            column.Settings.FilterMode = ColumnFilterMode.Value;
            column.ColumnType = MVCxGridViewColumnType.ComboBox;
            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
            comboSetting.Items.Add("", "");
            comboSetting.Items.Add("HIGH", "HIGH");
            comboSetting.Items.Add("MEDIUM", "MEDIUM");
            comboSetting.Items.Add("NORMAL", "NORMAL");
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
    });

    setting.Columns.AddBand(
    columnBand =>
    {
        columnBand.SetHeaderTemplateContent(
        content =>
        {
            Html.DevExpress().Label(label =>
            {
                label.Name = "N2Month" + columnBand.VisibleIndex;
                label.Text = "(N + 2)";

                if (Model.GetModel<FluctuationMonitoringData>().FMGridData != null)
                {
                    if (Model.GetModel<FluctuationMonitoringData>().FMGridData.Count > 0)
                    {
                        var visibleIndex = columnBand.VisibleIndex >= 0 ? columnBand.VisibleIndex : 0;

                        String packMonth = Convert.ToString(DataBinder.Eval(Model.GetModel<FluctuationMonitoringData>().FMGridData[visibleIndex], "PRODUCTION_MONTH"));
                        DateTime parseMonth = DateTime.ParseExact(packMonth, "yyyyMM", System.Globalization.CultureInfo.InvariantCulture).AddMonths(2);
                        String monthName = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(parseMonth.Month);

                        label.Text = monthName.Substring(0, 3) + " '" + parseMonth.Year.ToString().Substring(2, 2) + " (N + 2)";
                    }
                }
            }).Render();
        });

        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_2_VOLUME";
            column.Caption = "Qty";
            column.Width = Unit.Pixel(60);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });

        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_2_FA";
            column.Caption = "F/A Firm";
            column.Width = Unit.Pixel(80);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_2_FLUCTUATION";
            column.Caption = "Fluct. Category";
            //column.Width = Unit.Pixel(50);
            column.Settings.FilterMode = ColumnFilterMode.Value;
            column.ColumnType = MVCxGridViewColumnType.ComboBox;
            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
            comboSetting.Items.Add("", "");
            comboSetting.Items.Add("HIGH", "HIGH");
            comboSetting.Items.Add("MEDIUM", "MEDIUM");
            comboSetting.Items.Add("NORMAL", "NORMAL");
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "T_N_2_FA";
            column.Caption = "F/A Tentative";
            column.Width = Unit.Pixel(90);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "T_N_2_FLUCTUATION";
            column.Caption = "Fluct. Category";
            //column.Width = Unit.Pixel(50);
            column.Settings.FilterMode = ColumnFilterMode.Value;
            column.ColumnType = MVCxGridViewColumnType.ComboBox;
            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
            comboSetting.Items.Add("", "");
            comboSetting.Items.Add("HIGH", "HIGH");
            comboSetting.Items.Add("MEDIUM", "MEDIUM");
            comboSetting.Items.Add("NORMAL", "NORMAL");
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
    });

    setting.Columns.AddBand(
    columnBand =>
    {
        columnBand.SetHeaderTemplateContent(
        content =>
        {
            Html.DevExpress().Label(label =>
            {
                label.Name = "N3Month" + columnBand.VisibleIndex;
                label.Text = "(N + 3)";

                if (Model.GetModel<FluctuationMonitoringData>().FMGridData != null)
                {
                    if (Model.GetModel<FluctuationMonitoringData>().FMGridData.Count > 0)
                    {
                        var visibleIndex = columnBand.VisibleIndex >= 0 ? columnBand.VisibleIndex : 0;

                        String packMonth = Convert.ToString(DataBinder.Eval(Model.GetModel<FluctuationMonitoringData>().FMGridData[visibleIndex], "PRODUCTION_MONTH"));
                        DateTime parseMonth = DateTime.ParseExact(packMonth, "yyyyMM", System.Globalization.CultureInfo.InvariantCulture).AddMonths(3);
                        String monthName = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(parseMonth.Month);

                        label.Text = monthName.Substring(0, 3) + " '" + parseMonth.Year.ToString().Substring(2, 2) + " (N + 3)";
                    }
                }
            }).Render();
        });

        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_3_VOLUME";
            column.Caption = "Qty";
            column.Width = Unit.Pixel(60);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });

        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_3_FA";
            column.Caption = "F/A Firm";
            column.Width = Unit.Pixel(80);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "N_3_FLUCTUATION";
            column.Caption = "Fluct. Category";
            //column.Width = Unit.Pixel(50);
            column.Settings.FilterMode = ColumnFilterMode.Value;
            column.ColumnType = MVCxGridViewColumnType.ComboBox;
            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
            comboSetting.Items.Add("", "");
            comboSetting.Items.Add("HIGH", "HIGH");
            comboSetting.Items.Add("MEDIUM", "MEDIUM");
            comboSetting.Items.Add("NORMAL", "NORMAL");
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "T_N_3_FA";
            column.Caption = "F/A Tentative";
            column.Width = Unit.Pixel(90);
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
        columnBand.Columns.Add(column =>
        {
            column.FieldName = "T_N_3_FLUCTUATION";
            column.Caption = "Fluct. Category";
            //column.Width = Unit.Pixel(50);
            column.Settings.FilterMode = ColumnFilterMode.Value;
            column.ColumnType = MVCxGridViewColumnType.ComboBox;
            var comboSetting = column.PropertiesEdit as ComboBoxProperties;
            comboSetting.Items.Add("", "");
            comboSetting.Items.Add("HIGH", "HIGH");
            comboSetting.Items.Add("MEDIUM", "MEDIUM");
            comboSetting.Items.Add("NORMAL", "NORMAL");
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        });
    });

    setting.HtmlDataCellPrepared = (sender, e) =>
    {
        if (((e.DataColumn.FieldName == "N_FLUCTUATION")
            || (e.DataColumn.FieldName == "N_1_FLUCTUATION")
            || (e.DataColumn.FieldName == "N_2_FLUCTUATION")
            || (e.DataColumn.FieldName == "N_3_FLUCTUATION"))
            && (e.CellValue.ToString() == "HIGH"))
        {
            e.Cell.BackColor = System.Drawing.Color.Red;
        }

        if (((e.DataColumn.FieldName == "T_N_FLUCTUATION")
            || (e.DataColumn.FieldName == "T_N_1_FLUCTUATION")
            || (e.DataColumn.FieldName == "T_N_2_FLUCTUATION")
            || (e.DataColumn.FieldName == "T_N_3_FLUCTUATION"))
            && (e.CellValue.ToString() == "HIGH"))
        {
            e.Cell.BackColor = System.Drawing.Color.Red;
        }

        var gv = sender as MVCxGridView;
        string n_value = gv.GetRowValues(e.VisibleIndex, "N_FLUCTUATION").ToString();
        if ((n_value == "HIGH") && (e.DataColumn.FieldName == "N_FA"))
        {
            e.Cell.BackColor = System.Drawing.Color.Yellow;
        }

        string n_1_value = gv.GetRowValues(e.VisibleIndex, "N_1_FLUCTUATION").ToString();
        if ((n_1_value == "HIGH") && (e.DataColumn.FieldName == "N_1_FA"))
        {
            e.Cell.BackColor = System.Drawing.Color.Yellow;
        }

        string n_2_value = gv.GetRowValues(e.VisibleIndex, "N_2_FLUCTUATION").ToString();
        if ((n_2_value == "HIGH") && (e.DataColumn.FieldName == "N_2_FA"))
        {
            e.Cell.BackColor = System.Drawing.Color.Yellow;
        }

        string n_3_value = gv.GetRowValues(e.VisibleIndex, "N_3_FLUCTUATION").ToString();
        if ((n_3_value == "HIGH") && (e.DataColumn.FieldName == "N_3_FA"))
        {
            e.Cell.BackColor = System.Drawing.Color.Yellow;
        }

        string t_n_value = gv.GetRowValues(e.VisibleIndex, "T_N_FLUCTUATION").ToString();
        if ((t_n_value == "HIGH") && (e.DataColumn.FieldName == "T_N_FA"))
        {
            e.Cell.BackColor = System.Drawing.Color.Yellow;
        }

        string t_n_1_value = gv.GetRowValues(e.VisibleIndex, "T_N_1_FLUCTUATION").ToString();
        if ((t_n_1_value == "HIGH") && (e.DataColumn.FieldName == "T_N_1_FA"))
        {
            e.Cell.BackColor = System.Drawing.Color.Yellow;
        }

        string t_n_2_value = gv.GetRowValues(e.VisibleIndex, "T_N_2_FLUCTUATION").ToString();
        if ((t_n_2_value == "HIGH") && (e.DataColumn.FieldName == "T_N_2_FA"))
        {
            e.Cell.BackColor = System.Drawing.Color.Yellow;
        }

        string t_n_3_value = gv.GetRowValues(e.VisibleIndex, "T_N_3_FLUCTUATION").ToString();
        if ((t_n_3_value == "HIGH") && (e.DataColumn.FieldName == "T_N_3_FA"))
        {
            e.Cell.BackColor = System.Drawing.Color.Yellow;
        }
    };
    
}).Bind(Model.GetModel<Portal.Models.FluctuationMonitoring.FluctuationMonitoringData>().FMGridData).GetHtml()

